<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>Accept a payment</title>
<meta name="description" content="A demo of a payment on Stripe">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="checkout.css">
<style>
body { width: 96%; margin: auto; }
.wrap { width: 100%; height: auto; margin: 0 auto; padding: 20px 0; flex-flow: row wrap; }
.header { width: 90%; }
.header h1 { font-size: 1.6rem; }
.header h1, .header p { max-width: 600px; margin: 10px auto; line-height: 1.6; }
.header p + p { margin: -10px auto 10px; font-size: 14px; }
form { margin: auto; }
form .cart p { display: flex; flex-flow: row wrap; justify-content: space-between; align-items: baseline; font-size: 13px; }
form .cart input[type="text"] { width: 60px; text-align: right; }
pre { width: 100%; height: 300px; padding: 10px 20px; background: #000; overflow: auto; color: #fff; font-size: 11px; resize: vertical; }
.footer { text-align: right; }
@media only screen and (max-width: 600px) {
  form { width: 90vw; padding: 10px; }
}
</style>
</head>
<body>
<div class="wrap">
<div class="header">
<h1>Stripe Card Element</h1>
<p>決済用データについて</p>
<p>テスト用にフォーム内の金額や通貨を送信していますが、実際の設定は送信されるrawデータを使用するのではなく、送信されたデータに基づきサーバー側で設定するようにするべきです。</p>
<p>Stripeに送信するamountは通貨により小数点以下の数値の設定（例えばUSDなら $12.50 は 1250 として送信する等）や最低数値の設定があるため注意が必要です。</p>
</div>

<form id="card-form" method="POST">
<div class="cart">
<p>Test data
<label>Amount: $ 12.50 <input type="hidden" name="amount" value="1250"></label>
<label>Currency: USD <input type="hidden" name="currency" value="usd"></label>
</p>
<input type="hidden" name="description" value="">
<input type="hidden" name="city" value="">
<input type="hidden" name="country" value="">
<input type="hidden" name="line1" value="">
<input type="hidden" name="line2" value="">
<input type="hidden" name="postal_code" value="">
<input type="hidden" name="state" value="">
<input type="hidden" name="email" value="">
<input type="hidden" name="name" value="">
<input type="hidden" name="phone" value="">
</div>

<div id="card-element">
<!-- a Stripe Element will be inserted. -->
</div>
<button id="submitBtn">
<div class="spinner hidden" id="spinner"></div>
<span id="button-text">Pay now</span>
</button>
<div id="payment-message" class="hidden"></div>
</form>

<?php
// For check   データ確認用の出力です。確認後は削除してご利用ください。
if (!empty($_POST)) {
    echo '<pre>';
    echo 'フォーム送信データ' . PHP_EOL;
    var_dump($_POST);
    echo '</pre>';
}
if (!empty($_REQUEST['payment_intent'])) {
    // Stripe PHP SDK
    require_once 'vendor/autoload.php';
    // Load Stripe secret key
    require_once 'secrets.php';
    $stripe = new \Stripe\StripeClient($stripe_secret_key);
    // Retrieve payment intent
    $payment_intent_id = $_REQUEST['payment_intent'];
    $payment_intent = ($payment_intent_id) ? $stripe->paymentIntents->retrieve($payment_intent_id, []) ?? null : false;
    // Retrieve payment method
    $payment_method_id = $payment_intent->payment_method ?? '';
    $payment_method = ($payment_method_id) ? $stripe->paymentMethods->retrieve($payment_method_id, []) ?? null : false;
    // Retrieve charge (latest)
    $charge_id = $payment_intent->latest_charge ?? '';
    $charge = ($charge_id) ? $stripe->charges->retrieve($charge_id, []) ?? null : false;
    echo '<pre>';
    echo 'Stripeデータ' . PHP_EOL;
    var_dump($payment_intent);
    var_dump($payment_method);
    var_dump($charge);
    echo '</pre>';
}
?>

<div class="footer"><p><a href="./">Stripe Card Element</a></p></div>
</div>
<script src="https://js.stripe.com/v3/"></script>
<script src="card_element.js"></script>
</body>
</html>
